﻿<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

    protected void Button1_Click(object sender, EventArgs e)
    {
        System.Threading.Thread.Sleep(4000);
        Label1.Text = (int.Parse(TextBox1.Text) + int.Parse(TextBox2.Text)).ToString();
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Untitled Page</title>
    <script type="text/javascript">
    
      function pageLoad() {
        var prm = Sys.WebForms.PageRequestManager.getInstance();
        
        //add handlers for client-side ASP.NET AJAX Events
        prm.add_beginRequest(beginRequest);
        prm.add_endRequest(endRequest);
        prm.add_initializeRequest(initializeRequest);
        prm.add_pageLoaded(pageLoaded);
        prm.add_pageLoading(pageLoading);
      }
      
      //begin request event handler
      function beginRequest(sender, args){
        spnStatus.innerHTML = 'Begin request';
      }
      
      //end request event handler
      function endRequest(sender, args){
        spnStatus.innerHTML = 'Complete!';
      }
      
      //initialize request event handler
      function initializeRequest(sender, args){
          var prm = Sys.WebForms.PageRequestManager.getInstance();
          if (prm.get_isInAsyncPostBack() & args.get_postBackElement().id == 'btnCancel') {
             prm.abortPostBack();
          }
          else if (prm.get_isInAsyncPostBack() & args.get_postBackElement().id == 'btnSubmit') {
             args.set_cancel(true);
             spnStatus.innerHTML = 'Still processing, please wait...';
         }
          else if (!prm.get_isInAsyncPostBack() & args.get_postBackElement().id == 'btnSubmit') {
             spnStatus.innerHTML = 'Getting Results';
          }

      }
            
      //page loaded event handler
      function pageLoaded(sender, args){
        spnStatus.innerHTML = 'Page Loaded';
      }
      
      //page loading event handler
      function pageLoading(sender, args){
        spnStatus.innerHTML = 'Page Loading';
      }
    </script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:ScriptManager ID="ScriptManager1" runat="server" />
        <asp:UpdatePanel ID="UpdatePanel1" runat="server">
            <ContentTemplate>
                <table>
                    <tr>
                        <td>Number 1:</td>
                        <td>
                            <asp:TextBox ID="TextBox1" runat="server"></asp:TextBox></td>
                    </tr>
                    <tr>
                        <td>Number 2:</td>
                        <td>
                            <asp:TextBox ID="TextBox2" runat="server"></asp:TextBox></td>
                    </tr>
                    <tr>
                        <td>Result:</td>
                        <td>
                            <asp:Label ID="Label1" runat="server"></asp:Label></td>
                    </tr>
                    <tr>
                        <td><asp:Button ID="btnCancel" runat="server" Text="Cancel" /></td>
                        <td>
                            <asp:Button ID="btnSubmit" runat="server" Text="Get Result" 
                                onclick="Button1_Click" /></td>
                    </tr>
                    <tr>
                        <td colspan="2"><span id="spnStatus"></span></td>
                    </tr>
                </table>
            </ContentTemplate>
        </asp:UpdatePanel>
    </div>
    </form>
</body>
</html>
