﻿<%@ Page Language="C#" %>
<%@ Import Namespace="System.Web.Script.Serialization" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected void cmdSerializeClass_Click(object sender, EventArgs e)
    {
        Employee emp = new Employee();
        emp.ID = int.Parse(txtID.Text.Trim());
        emp.FirstName = txtFirstName.Text.Trim();
        emp.LastName = txtLastName.Text.Trim();
        JavaScriptSerializer jsSerializer = new JavaScriptSerializer();
        StringBuilder sb = new StringBuilder();
        jsSerializer.Serialize(emp, sb);
        lblSerialized.Text = sb.ToString();
    }

</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Untitled Page</title>
    <script type="text/javascript">
    
      function pageLoad() {
      }
      
      function getSerializedEmployee(){
        var emp = Sys.Serialization.JavaScriptSerializer.deserialize(<%=lblSerialized.ClientID %>.innerText);
        document.getElementById('txtClientID').value = emp.ID;
        document.getElementById('txtClientFirstName').value = emp.FirstName;
        document.getElementById('txtClientLastName').value = emp.LastName;
      }
      
      function saveEmployee(){
        var emp = Sys.Serialization.JavaScriptSerializer.deserialize(<%=lblSerialized.ClientID %>.innerText);
        emp.ID = document.getElementById('txtClientID').value
        emp.FirstName = document.getElementById('txtClientFirstName').value
        emp.LastName = document.getElementById('txtClientLastName').value
        
        <%=lblSerialized.ClientID %>.innerText = Sys.Serialization.JavaScriptSerializer.serialize(emp);
      }
    
    </script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:ScriptManager ID="ScriptManager1" runat="server" />
        
    </div>
    <table>
        <tr>
            <td colspan="2"><h2>Server-Side</h2></td>
        </tr>
        <tr>
            <td>ID:</td>
            <td>
                <asp:TextBox ID="txtID" runat="server"></asp:TextBox>
            </td>
        </tr>
        <tr>
            <td>First Name:</td>
            <td>
                <asp:TextBox ID="txtFirstName" runat="server"></asp:TextBox>
            </td>
        </tr>
        <tr>
            <td>Last Name:</td>
            <td>
                <asp:TextBox ID="txtLastName" runat="server"></asp:TextBox>
            </td>
        </tr>
        <tr>
            <td></td>
            <td>
                <asp:Button ID="cmdSerializeClass" runat="server" Text="Serialize Class" 
                    onclick="cmdSerializeClass_Click" /></td>
        </tr>
        <tr>
            <td>Serialized Class Instance: </td>
            <td><asp:Label ID="lblSerialized" runat="server" Text=""></asp:Label></td>
        </tr>
    </table>    
    
    <br />
    <hr />
    <br />    
    <table>
       <tr>
            <td colspan="2"><h2>Client-Side</h2></td>
        </tr>
        <tr>
            <td colspan="2"><input type="button" id="cmdGetInstance" value="Get Saved Instance" onclick="javascript:getSerializedEmployee();" /></td>
        </tr>
        <tr>
            <td>ID:</td>
            <td><input type="text" id="txtClientID" /></td>
        </tr>        
        <tr>
            <td>First Name:</td>
            <td><input type="text" id="txtClientFirstName" /></td>
        </tr>        
        <tr>
            <td>Last Name:</td>
            <td><input type="text" id="txtClientLastName" /></td>
        </tr>        
        <tr>
            <td colspan="2"><input type="button" id="cmdSaveEmployee" value="Save Client Employee Instance" onclick="javascript:saveEmployee();" /></td>
        </tr>
    </table>
    </form>
</body>
</html>
